diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index d592655258..a79fbf0e69 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -1391,545 +253,268 @@ extractRelOptions(HeapTuple tuple, TupleDesc tupdesc,
 	/* Parse into appropriate format; don't error out here */
 	switch (classForm->relkind)
 	{
-		case RELKIND_RELATION:
 		case RELKIND_TOASTVALUE:
+			spec_set = get_toast_relopt_spec_set();
+			break;
+		case RELKIND_RELATION:
 		case RELKIND_MATVIEW:
-			options = heap_reloptions(classForm->relkind, datum, false);
+			spec_set = get_heap_relopt_spec_set();
 			break;
 		case RELKIND_PARTITIONED_TABLE:
-			options = partitioned_table_reloptions(datum, false);
+			spec_set = get_partitioned_relopt_spec_set();
 			break;
 		case RELKIND_VIEW:
-			options = view_reloptions(datum, false);
+			spec_set = get_view_relopt_spec_set();
 			break;
 		case RELKIND_INDEX:
 		case RELKIND_PARTITIONED_INDEX:
-			options = index_reloptions(amoptions, datum, false);
+			if (amoptionsspecsetfn)
+				spec_set = amoptionsspecsetfn();
+			else
+				spec_set = NULL;
 			break;
 		case RELKIND_FOREIGN_TABLE:
-			options = NULL;
+			spec_set = NULL;
 			break;
 		default:
 			Assert(false);		/* can't get here */
-			options = NULL;		/* keep compiler quiet */
+			spec_set = NULL;		/* keep compiler quiet */
 			break;
 	}
-
+	if (spec_set)
+		options = optionsTextArrayToBytea(spec_set, datum, 0);
+	else
+		options = NULL;
 	return options;
 }
 
-static void
-parseRelOptionsInternal(Datum options, bool validate,
-						relopt_value *reloptions, int numoptions)
-{
-	ArrayType  *array = DatumGetArrayTypeP(options);
-	Datum	   *optiondatums;
-	int			noptions;
-	int			i;
-
-	deconstruct_array(array, TEXTOID, -1, false, TYPALIGN_INT,
-					  &optiondatums, NULL, &noptions);
-
-	for (i = 0; i < noptions; i++)
-	{
-		char	   *text_str = VARDATA(optiondatums[i]);
-		int			text_len = VARSIZE(optiondatums[i]) - VARHDRSZ;
-		int			j;
-
-		/* Search for a match in reloptions */
-		for (j = 0; j < numoptions; j++)
-		{
-			int			kw_len = reloptions[j].gen->namelen;
-
-			if (text_len > kw_len && text_str[kw_len] == '=' &&
-				strncmp(text_str, reloptions[j].gen->name, kw_len) == 0)
-			{
-				parse_one_reloption(&reloptions[j], text_str, text_len,
-									validate);
-				break;
-			}
-		}
-
-		if (j >= numoptions && validate)
-		{
-			char	   *s;
-			char	   *p;
-
-			s = TextDatumGetCString(optiondatums[i]);
-			p = strchr(s, '=');
-			if (p)
-				*p = '\0';
-			ereport(ERROR,
-					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-					 errmsg("unrecognized parameter \"%s\"", s)));
-		}
-	}
-
-	/* It's worth avoiding memory leaks in this function */
-	pfree(optiondatums);
-
-	if (((void *) array) != DatumGetPointer(options))
-		pfree(array);
-}
-
-/*
- * Interpret reloptions that are given in text-array format.
- *
- * options is a reloption text array as constructed by transformRelOptions.
- * kind specifies the family of options to be processed.
- *
- * The return value is a relopt_value * array on which the options actually
- * set in the options array are marked with isset=true.  The length of this
- * array is returned in *numrelopts.  Options not set are also present in the
- * array; this is so that the caller can easily locate the default values.
- *
- * If there are no options of the given kind, numrelopts is set to 0 and NULL
- * is returned (unless options are illegally supplied despite none being
- * defined, in which case an error occurs).
- *
- * Note: values of type int, bool and real are allocated as part of the
- * returned array.  Values of type string are allocated separately and must
- * be freed by the caller.
- */
-static relopt_value *
-parseRelOptions(Datum options, bool validate, relopt_kind kind,
-				int *numrelopts)
-{
-	relopt_value *reloptions = NULL;
-	int			numoptions = 0;
-	int			i;
-	int			j;
-
-	if (need_initialization)
-		initialize_reloptions();
-
-	/* Build a list of expected options, based on kind */
-
-	for (i = 0; relOpts[i]; i++)
-		if (relOpts[i]->kinds & kind)
-			numoptions++;
-
-	if (numoptions > 0)
-	{
-		reloptions = palloc(numoptions * sizeof(relopt_value));
-
-		for (i = 0, j = 0; relOpts[i]; i++)
-		{
-			if (relOpts[i]->kinds & kind)
-			{
-				reloptions[j].gen = relOpts[i];
-				reloptions[j].isset = false;
-				j++;
-			}
-		}
-	}
-
-	/* Done if no options */
-	if (PointerIsValid(DatumGetPointer(options)))
-		parseRelOptionsInternal(options, validate, reloptions, numoptions);
-
-	*numrelopts = numoptions;
-	return reloptions;
-}
-
-/* Parse local unregistered options. */
-static relopt_value *
-parseLocalRelOptions(local_relopts *relopts, Datum options, bool validate)
+void
+oid_postvalidate(option_value* value)
 {
-	int			nopts = list_length(relopts->options);
-	relopt_value *values = palloc(sizeof(*values) * nopts);
-	ListCell   *lc;
-	int			i = 0;
-
-	foreach(lc, relopts->options)
-	{
-		local_relopt *opt = lfirst(lc);
-
-		values[i].gen = opt->option;
-		values[i].isset = false;
-
-		i++;
-	}
-
-	if (options != (Datum) 0)
-		parseRelOptionsInternal(options, validate, values, nopts);
-
-	return values;
+	if (value->values.bool_val)
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				errmsg("tables declared WITH OIDS are not supported")));
 }
 
 /*
- * Subroutine for parseRelOptions, to parse and validate a single option's
- * value
+ * These toast options are can't be set via SQL, but we should set them
+ * to their defaults in binary representation, to make postgres work properly
  */
 static void
-parse_one_reloption(relopt_value *option, char *text_str, int text_len,
-					bool validate)
-{
-	char	   *value;
-	int			value_len;
-	bool		parsed;
-	bool		nofree = false;
-
-	if (option->isset && validate)
-		ereport(ERROR,
-				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-				 errmsg("parameter \"%s\" specified more than once",
-						option->gen->name)));
-
-	value_len = text_len - option->gen->namelen - 1;
-	value = (char *) palloc(value_len + 1);
-	memcpy(value, text_str + option->gen->namelen + 1, value_len);
-	value[value_len] = '\0';
-
-	switch (option->gen->type)
-	{
-		case RELOPT_TYPE_BOOL:
-			{
-				parsed = parse_bool(value, &option->values.bool_val);
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for boolean option \"%s\": %s",
-									option->gen->name, value)));
-			}
-			break;
-		case RELOPT_TYPE_INT:
-			{
-				relopt_int *optint = (relopt_int *) option->gen;
-
-				parsed = parse_int(value, &option->values.int_val, 0, NULL);
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for integer option \"%s\": %s",
-									option->gen->name, value)));
-				if (validate && (option->values.int_val < optint->min ||
-								 option->values.int_val > optint->max))
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("value %s out of bounds for option \"%s\"",
-									value, option->gen->name),
-							 errdetail("Valid values are between \"%d\" and \"%d\".",
-									   optint->min, optint->max)));
-			}
-			break;
-		case RELOPT_TYPE_REAL:
-			{
-				relopt_real *optreal = (relopt_real *) option->gen;
-
-				parsed = parse_real(value, &option->values.real_val, 0, NULL);
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for floating point option \"%s\": %s",
-									option->gen->name, value)));
-				if (validate && (option->values.real_val < optreal->min ||
-								 option->values.real_val > optreal->max))
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("value %s out of bounds for option \"%s\"",
-									value, option->gen->name),
-							 errdetail("Valid values are between \"%f\" and \"%f\".",
-									   optreal->min, optreal->max)));
-			}
-			break;
-		case RELOPT_TYPE_ENUM:
-			{
-				relopt_enum *optenum = (relopt_enum *) option->gen;
-				relopt_enum_elt_def *elt;
-
-				parsed = false;
-				for (elt = optenum->members; elt->string_val; elt++)
-				{
-					if (pg_strcasecmp(value, elt->string_val) == 0)
-					{
-						option->values.enum_val = elt->symbol_val;
-						parsed = true;
-						break;
-					}
-				}
-				if (validate && !parsed)
-					ereport(ERROR,
-							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-							 errmsg("invalid value for enum option \"%s\": %s",
-									option->gen->name, value),
-							 optenum->detailmsg ?
-							 errdetail_internal("%s", _(optenum->detailmsg)) : 0));
-
-				/*
-				 * If value is not among the allowed string values, but we are
-				 * not asked to validate, just use the default numeric value.
-				 */
-				if (!parsed)
-					option->values.enum_val = optenum->default_val;
-			}
-			break;
-		case RELOPT_TYPE_STRING:
-			{
-				relopt_string *optstring = (relopt_string *) option->gen;
-
-				option->values.string_val = value;
-				nofree = true;
-				if (validate && optstring->validate_cb)
-					(optstring->validate_cb) (value);
-				parsed = true;
-			}
-			break;
-		default:
-			elog(ERROR, "unsupported reloption type %d", option->gen->type);
-			parsed = true;		/* quiet compiler */
-			break;
+toast_options_postprocess(void *data, bool validate)
+{
+	StdRdOptions * toast_options = (StdRdOptions *) data;
+	toast_options->fillfactor = 100;
+	toast_options->autovacuum.analyze_threshold = -1;
+	toast_options->autovacuum.analyze_scale_factor = -1;
+}
+
+
+options_spec_set *
+get_stdrd_relopt_spec_set(bool is_heap)
+{
+	options_spec_set * stdrd_relopt_spec_set = allocateOptionsSpecSet(
+					is_heap ? NULL : "toast",  sizeof(StdRdOptions), false, 0);
+	if (!is_heap)
+		stdrd_relopt_spec_set->postprocess_fun = toast_options_postprocess;
+
+	if (is_heap)
+		optionsSpecSetAddInt(stdrd_relopt_spec_set, "fillfactor",
+							"Packs table pages only to this percentag",
+							ShareUpdateExclusiveLock, /* since it applies only
+													   * to later inserts */
+							offsetof(StdRdOptions, fillfactor),  NULL,
+							HEAP_DEFAULT_FILLFACTOR, HEAP_MIN_FILLFACTOR, 100);
+
+	optionsSpecSetAddBool(stdrd_relopt_spec_set, "autovacuum_enabled",
+							"Enables autovacuum in this relation",
+							ShareUpdateExclusiveLock,
+							offsetof(StdRdOptions, autovacuum) +
+												offsetof(AutoVacOpts, enabled),
+							NULL, true);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_vacuum_threshold",
+							"Minimum number of tuple updates or deletes prior to vacuum",
+							ShareUpdateExclusiveLock,
+							offsetof(StdRdOptions, autovacuum) +
+									   offsetof(AutoVacOpts, vacuum_threshold),
+							NULL, -1, 0, INT_MAX);
+
+	if (is_heap)
+		optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_analyze_threshold",
+							 "Minimum number of tuple updates or deletes prior to vacuum",
+							 ShareUpdateExclusiveLock,
+							 offsetof(StdRdOptions, autovacuum) +
+									  offsetof(AutoVacOpts, analyze_threshold),
+							 NULL, -1, 0, INT_MAX);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_vacuum_cost_limit",
+						 "Vacuum cost amount available before napping, for autovacuum",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+									  offsetof(AutoVacOpts, vacuum_cost_limit),
+						 NULL, -1, 0, 10000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_freeze_min_age",
+						 "Minimum age at which VACUUM should freeze a table row, for autovacuum",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+										 offsetof(AutoVacOpts, freeze_min_age),
+						 NULL, -1, 0, 1000000000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_freeze_max_age",
+						 "Age at which to autovacuum a table to prevent transaction ID wraparound",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+										 offsetof(AutoVacOpts, freeze_max_age),
+						 NULL, -1, 100000, 2000000000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_freeze_table_age",
+						 "Age at which VACUUM should perform a full table sweep to freeze row versions",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+									   offsetof(AutoVacOpts, freeze_table_age),
+						 NULL, -1, 0, 2000000000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_multixact_freeze_min_age",
+						 "Minimum multixact age at which VACUUM should freeze a row multixact's, for autovacuum",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+							   offsetof(AutoVacOpts, multixact_freeze_min_age),
+						 NULL, -1, 0, 1000000000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_multixact_freeze_max_age",
+						 "Multixact age at which to autovacuum a table to prevent multixact wraparound",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+							   offsetof(AutoVacOpts, multixact_freeze_max_age),
+						 NULL, -1, 10000, 2000000000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set, "autovacuum_multixact_freeze_table_age",
+						 "Age of multixact at which VACUUM should perform a full table sweep to freeze row versions",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+							 offsetof(AutoVacOpts, multixact_freeze_table_age),
+						 NULL, -1, 0, 2000000000);
+
+	optionsSpecSetAddInt(stdrd_relopt_spec_set,"log_autovacuum_min_duration",
+						 "Sets the minimum execution time above which autovacuum actions will be logged",
+						 ShareUpdateExclusiveLock,
+						 offsetof(StdRdOptions, autovacuum) +
+									   offsetof(AutoVacOpts, log_min_duration),
+						 NULL, -1, -1, INT_MAX);
+
+	optionsSpecSetAddReal(stdrd_relopt_spec_set, "autovacuum_vacuum_cost_delay",
+						  "Vacuum cost delay in milliseconds, for autovacuum",
+						  ShareUpdateExclusiveLock,
+						  offsetof(StdRdOptions, autovacuum) +
+									  offsetof(AutoVacOpts, vacuum_cost_delay),
+						  NULL, -1, 0.0, 100.0);
+
+	optionsSpecSetAddReal(stdrd_relopt_spec_set, "autovacuum_vacuum_scale_factor",
+						  "Number of tuple updates or deletes prior to vacuum as a fraction of reltuples",
+						  ShareUpdateExclusiveLock,
+						  offsetof(StdRdOptions, autovacuum) +
+									offsetof(AutoVacOpts, vacuum_scale_factor),
+						  NULL,  -1, 0.0, 100.0);
+
+	optionsSpecSetAddReal(stdrd_relopt_spec_set, "autovacuum_vacuum_insert_scale_factor",
+						  "Number of tuple inserts prior to vacuum as a fraction of reltuples",
+						  ShareUpdateExclusiveLock,
+						  offsetof(StdRdOptions, autovacuum) +
+								offsetof(AutoVacOpts, vacuum_ins_scale_factor),
+						  NULL,  -1, 0.0, 100.0);
+	if (is_heap)
+	{
+		optionsSpecSetAddReal(stdrd_relopt_spec_set, "autovacuum_analyze_scale_factor",
+							  "Number of tuple inserts, updates or deletes prior to analyze as a fraction of reltuples",
+							  ShareUpdateExclusiveLock,
+							  offsetof(StdRdOptions, autovacuum) +
+								   offsetof(AutoVacOpts, analyze_scale_factor),
+							  NULL,  -1, 0.0, 100.0);
+
+		optionsSpecSetAddInt(stdrd_relopt_spec_set, "toast_tuple_target",
+							 "Sets the target tuple length at which external columns will be toasted",
+							 ShareUpdateExclusiveLock,
+							 offsetof(StdRdOptions, toast_tuple_target),
+							 NULL, TOAST_TUPLE_TARGET, 128,
+							 TOAST_TUPLE_TARGET_MAIN);
+
+		optionsSpecSetAddBool(stdrd_relopt_spec_set, "user_catalog_table",
+							  "Declare a table as an additional catalog table, e.g. for the purpose of logical replication",
+							  AccessExclusiveLock,
+							  offsetof(StdRdOptions, user_catalog_table),
+							  NULL, false);
+
+		optionsSpecSetAddInt(stdrd_relopt_spec_set, "parallel_workers",
+							 "Number of parallel processes that can be used per executor node for this relation.",
+							 ShareUpdateExclusiveLock,
+							 offsetof(StdRdOptions, parallel_workers),
+							 NULL, -1, 0, 1024);
 	}
 
-	if (parsed)
-		option->isset = true;
-	if (!nofree)
-		pfree(value);
-}
-
-/*
- * Given the result from parseRelOptions, allocate a struct that's of the
- * specified base size plus any extra space that's needed for string variables.
- *
- * "base" should be sizeof(struct) of the reloptions struct (StdRdOptions or
- * equivalent).
- */
-static void *
-allocateReloptStruct(Size base, relopt_value *options, int numoptions)
-{
-	Size		size = base;
-	int			i;
-
-	for (i = 0; i < numoptions; i++)
-	{
-		relopt_value *optval = &options[i];
-
-		if (optval->gen->type == RELOPT_TYPE_STRING)
-		{
-			relopt_string *optstr = (relopt_string *) optval->gen;
-
-			if (optstr->fill_cb)
-			{
-				const char *val = optval->isset ? optval->values.string_val :
-				optstr->default_isnull ? NULL : optstr->default_val;
-
-				size += optstr->fill_cb(val, NULL);
-			}
-			else
-				size += GET_STRING_RELOPTION_LEN(*optval) + 1;
-		}
+	optionsSpecSetAddEnum(stdrd_relopt_spec_set, "vacuum_index_cleanup",
+						  "Controls index vacuuming and index cleanup",
+						  ShareUpdateExclusiveLock,
+						  offsetof(StdRdOptions, vacuum_index_cleanup),
+						  NULL, StdRdOptIndexCleanupValues,
+						  STDRD_OPTION_VACUUM_INDEX_CLEANUP_AUTO,
+						  gettext_noop("Valid values are \"on\", \"off\", and \"auto\"."));
+
+	optionsSpecSetAddBool(stdrd_relopt_spec_set, "vacuum_truncate",
+						  "Enables vacuum to truncate empty pages at the end of this table",
+						  ShareUpdateExclusiveLock,
+						  offsetof(StdRdOptions, vacuum_truncate),
+						  NULL, true);
+
+	if (is_heap)
+	{
+		optionsSpecSetAddBool(stdrd_relopt_spec_set, "oids",
+							  "Backward compatibility option. Will do nothing when false, will throw error when true",
+							  NoLock,
+							  -1, /* Do not actually store it's value */
+							  &oid_postvalidate, false);
 	}
 
-	return palloc0(size);
+	return stdrd_relopt_spec_set;
 }
 
-/*
- * Given the result of parseRelOptions and a parsing table, fill in the
- * struct (previously allocated with allocateReloptStruct) with the parsed
- * values.
- *
- * rdopts is the pointer to the allocated struct to be filled.
- * basesize is the sizeof(struct) that was passed to allocateReloptStruct.
- * options, of length numoptions, is parseRelOptions' output.
- * elems, of length numelems, is the table describing the allowed options.
- * When validate is true, it is expected that all options appear in elems.
- */
-static void
-fillRelOptions(void *rdopts, Size basesize,
-			   relopt_value *options, int numoptions,
-			   bool validate,
-			   const relopt_parse_elt *elems, int numelems)
-{
-	int			i;
-	int			offset = basesize;
 
-	for (i = 0; i < numoptions; i++)
-	{
-		int			j;
-		bool		found = false;
+static options_spec_set *heap_relopt_spec_set = NULL;
 
-		for (j = 0; j < numelems; j++)
-		{
-			if (strcmp(options[i].gen->name, elems[j].optname) == 0)
-			{
-				relopt_string *optstring;
-				char	   *itempos = ((char *) rdopts) + elems[j].offset;
-				char	   *string_val;
-
-				switch (options[i].gen->type)
-				{
-					case RELOPT_TYPE_BOOL:
-						*(bool *) itempos = options[i].isset ?
-							options[i].values.bool_val :
-							((relopt_bool *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_INT:
-						*(int *) itempos = options[i].isset ?
-							options[i].values.int_val :
-							((relopt_int *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_REAL:
-						*(double *) itempos = options[i].isset ?
-							options[i].values.real_val :
-							((relopt_real *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_ENUM:
-						*(int *) itempos = options[i].isset ?
-							options[i].values.enum_val :
-							((relopt_enum *) options[i].gen)->default_val;
-						break;
-					case RELOPT_TYPE_STRING:
-						optstring = (relopt_string *) options[i].gen;
-						if (options[i].isset)
-							string_val = options[i].values.string_val;
-						else if (!optstring->default_isnull)
-							string_val = optstring->default_val;
-						else
-							string_val = NULL;
-
-						if (optstring->fill_cb)
-						{
-							Size		size =
-							optstring->fill_cb(string_val,
-											   (char *) rdopts + offset);
-
-							if (size)
-							{
-								*(int *) itempos = offset;
-								offset += size;
-							}
-							else
-								*(int *) itempos = 0;
-						}
-						else if (string_val == NULL)
-							*(int *) itempos = 0;
-						else
-						{
-							strcpy((char *) rdopts + offset, string_val);
-							*(int *) itempos = offset;
-							offset += strlen(string_val) + 1;
-						}
-						break;
-					default:
-						elog(ERROR, "unsupported reloption type %d",
-							 options[i].gen->type);
-						break;
-				}
-				found = true;
-				break;
-			}
-		}
-		if (validate && !found)
-			elog(ERROR, "reloption \"%s\" not found in parse table",
-				 options[i].gen->name);
-	}
-	SET_VARSIZE(rdopts, offset);
+options_spec_set *
+get_heap_relopt_spec_set(void)
+{
+	if (heap_relopt_spec_set)
+		return heap_relopt_spec_set;
+	heap_relopt_spec_set = get_stdrd_relopt_spec_set(true);
+	return heap_relopt_spec_set;
 }
 
+static options_spec_set *toast_relopt_spec_set = NULL;
 
-/*
- * Option parser for anything that uses StdRdOptions.
- */
-bytea *
-default_reloptions(Datum reloptions, bool validate, relopt_kind kind)
+options_spec_set *
+get_toast_relopt_spec_set(void)
 {
-	static const relopt_parse_elt tab[] = {
-		{"fillfactor", RELOPT_TYPE_INT, offsetof(StdRdOptions, fillfactor)},
-		{"autovacuum_enabled", RELOPT_TYPE_BOOL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, enabled)},
-		{"autovacuum_vacuum_threshold", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_threshold)},
-		{"autovacuum_vacuum_insert_threshold", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_ins_threshold)},
-		{"autovacuum_analyze_threshold", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, analyze_threshold)},
-		{"autovacuum_vacuum_cost_limit", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_cost_limit)},
-		{"autovacuum_freeze_min_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_min_age)},
-		{"autovacuum_freeze_max_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_max_age)},
-		{"autovacuum_freeze_table_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_table_age)},
-		{"autovacuum_multixact_freeze_min_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_min_age)},
-		{"autovacuum_multixact_freeze_max_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_max_age)},
-		{"autovacuum_multixact_freeze_table_age", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_table_age)},
-		{"log_autovacuum_min_duration", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, log_min_duration)},
-		{"toast_tuple_target", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, toast_tuple_target)},
-		{"autovacuum_vacuum_cost_delay", RELOPT_TYPE_REAL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_cost_delay)},
-		{"autovacuum_vacuum_scale_factor", RELOPT_TYPE_REAL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_scale_factor)},
-		{"autovacuum_vacuum_insert_scale_factor", RELOPT_TYPE_REAL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_ins_scale_factor)},
-		{"autovacuum_analyze_scale_factor", RELOPT_TYPE_REAL,
-		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, analyze_scale_factor)},
-		{"user_catalog_table", RELOPT_TYPE_BOOL,
-		offsetof(StdRdOptions, user_catalog_table)},
-		{"parallel_workers", RELOPT_TYPE_INT,
-		offsetof(StdRdOptions, parallel_workers)},
-		{"vacuum_index_cleanup", RELOPT_TYPE_ENUM,
-		offsetof(StdRdOptions, vacuum_index_cleanup)},
-		{"vacuum_truncate", RELOPT_TYPE_BOOL,
-		offsetof(StdRdOptions, vacuum_truncate)}
-	};
-
-	return (bytea *) build_reloptions(reloptions, validate, kind,
-									  sizeof(StdRdOptions),
-									  tab, lengthof(tab));
+	if (toast_relopt_spec_set)
+		return toast_relopt_spec_set;
+	toast_relopt_spec_set = get_stdrd_relopt_spec_set(false);
+	return toast_relopt_spec_set;
 }
 
-/*
- * build_reloptions
- *
- * Parses "reloptions" provided by the caller, returning them in a
- * structure containing the parsed options.  The parsing is done with
- * the help of a parsing table describing the allowed options, defined
- * by "relopt_elems" of length "num_relopt_elems".
- *
- * "validate" must be true if reloptions value is freshly built by
- * transformRelOptions(), as opposed to being read from the catalog, in which
- * case the values contained in it must already be valid.
- *
- * NULL is returned if the passed-in options did not match any of the options
- * in the parsing table, unless validate is true in which case an error would
- * be reported.
- */
-void *
-build_reloptions(Datum reloptions, bool validate,
-				 relopt_kind kind,
-				 Size relopt_struct_size,
-				 const relopt_parse_elt *relopt_elems,
-				 int num_relopt_elems)
-{
-	int			numoptions;
-	relopt_value *options;
-	void	   *rdopts;
-
-	/* parse options specific to given relation option kind */
-	options = parseRelOptions(reloptions, validate, kind, &numoptions);
-	Assert(numoptions <= num_relopt_elems);
+static options_spec_set *partitioned_relopt_spec_set = NULL;
 
-	/* if none set, we're done */
-	if (numoptions == 0)
-	{
-		Assert(options == NULL);
-		return NULL;
-	}
-
-	/* allocate and fill the structure */
-	rdopts = allocateReloptStruct(relopt_struct_size, options, numoptions);
-	fillRelOptions(rdopts, relopt_struct_size, options, numoptions,
-				   validate, relopt_elems, num_relopt_elems);
-
-	pfree(options);
+options_spec_set *
+get_partitioned_relopt_spec_set(void)
+{
+	if (partitioned_relopt_spec_set)
+		return partitioned_relopt_spec_set;
+	partitioned_relopt_spec_set = allocateOptionsSpecSet(
+					NULL,  sizeof(StdRdOptions), false, 0);
+	/* No options for now, so spec set is empty */
 
-	return rdopts;
+	return partitioned_relopt_spec_set;
 }
 
 /*
